#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 100;

ofstream out("permutare.out");

int ffst[MAX_N];
int fsnd[MAX_N];

int fst[MAX_N];
int snd[MAX_N];

int type;
int n;
int at = 0;
int p;

bool check()
{
    at++;
    if (type == 1 && at == p) {

        for (int i = 1; i <= n; ++i)
            out << fst[i] << " ";

        for (int i = 1; i <= n; ++i)
            out << snd[i] << " ";

        out << "\n";
        return true;
    }

    if (type == 2) {
        for (int i = 1; i <= n; ++i) {
            if (fst[i] != ffst[i] || snd[i] != fsnd[i])
                return false;
        }

        out << at << "\n";
        return true;
    }

    return false;
}

bool back(int f, int s)
{
    if (f == n + 1 && s == n + 1) {
        return check();
    }

    if (f <= n) {
        fst[f] = (f + s - 1);
        if (back(f + 1, s))
            return true;
    }

    if (s < f) {
        snd[s] = (f + s - 1);
        if (back(f, s + 1))
            return true;
    }

    return false;
}

void process(const string &s)
{
    stringstream ss(s);
    ss >> type;
    at = 0;

    if (type == 1) {
        ss >> n >> p;
        back(1, 1);
    } else {
        ss >> n;

        for(int i = 1; i <= n; ++i)
            ss >> ffst[i];

        for(int i = 1; i <= n; ++i)
            ss >> fsnd[i];
        back(1, 1);
    }
}

int main()
{
    ifstream in("permutare.in");
    string s;

    while (true) {
        getline(in, s);
        if (in.eof())
            break;

        process(s);
    }
}
