#include <iostream>
#include <fstream>

using namespace std;

int n,c,d[1001],q[1001], ca,drumtotal=0;

void read()
{
    ifstream fin("fermier.in");
    fin>>n;
    fin>>c;
    for(int i=0;i<=n;i++)
        fin>>d[i];
    for(int i=1;i<=n;i++)
        fin>>q[i];
    ca=c;
}

int dmin(int x, int y)
{
    int k1=0,k2=0;
    if(y>=x)
    {
    for(int i=x;i<y;i++)
        k1=k1+d[i];
    for(int i=x-1;i>=0;i--)
        k2=k2+d[i];
    for(int i=n;i>=y;i--)
        k2=k2+d[i];
    }
    else
    {
    for(int i=x;i<=n;i++)
        k1=k1+d[i];
    for(int i=0;i<y;i++)
        k1=k1+d[i];
    for(int i=x-1;i>=y;i--)
        k2=k2+d[i];
    }
//    cout<<x<<' '<<y<<' '<<k1<<' '<<k2<<endl;
    if(k2>k1) return k1;
    return k2;
}

void solve()
{
    int x=0, y=1;
    while(q[n]>0)
    {
        if(ca>0)
        {
                drumtotal=drumtotal+dmin(x,y);
                x=y;
                if(ca>=q[y])
                {
                    ca=ca-q[y];
                    q[y]=0;
                    y++;
                }
                else
                {
                    q[y]=q[y]-ca;
                    ca=0;
                }
        }
        else
        {
            ca=c;
            drumtotal=drumtotal+dmin(x,0);
            x=0;
        }
    }
    if(x!=0)
        drumtotal=drumtotal+dmin(x,0);
}

int main()
{
    ofstream fout("fermier.out");
    read();
   solve();
   fout<<drumtotal;
    return 0;
}
