//Dana Lica
#include <cstdio>
#include <cstring>
#include <algorithm>
#define inf 100001
#define Nmax 1010

using namespace std;

struct curs {int first; int second;};

curs A[Nmax];
int N, K, T, Max, Lg;

void sortN2_second(curs A[Nmax]){
    curs aux;

    for(int i=1; i<N; i++)
        for(int j=i+1; j<=N; j++)
           if(A[i].second>A[j].second || A[i].second== A[j].second && A[i].first>A[j].first)
                aux=A[i], A[i]=A[j], A[j]=aux;
}
void sortN2_first(curs A[Nmax]){
    curs aux;

    for(int i=1; i<N; i++)
        for(int j=i+1; j<=N; j++)
           if(A[i].first>A[j].first)
                aux=A[i], A[i]=A[j], A[j]=aux;
}

int solve_1(curs A[Nmax]){
    int nr = 1, Sala[Nmax], Min, poz;
    memset(Sala,0,sizeof(Sala));

    sortN2_second(A);
    Sala[1]=A[1].second;
    for(int i=2; i<=N; i++){
        Min = inf;
        for(int j=1; j<=K; j++)
        if (A[i].first>=Sala[j] && Min> A[i].first - Sala[j]){
            Min = A[i].first - Sala[j];
            poz = j;
        }
        if(Min!= inf){ nr++; Sala[poz]=A[i].second;}
    }
    return nr;
}

int solve_2(curs A[Nmax])
{
    int i, tmax=0, ans;

    sortN2_first(A);

    for(i=1; i<=N; ++i)
        tmax = max(tmax, A[i].second - A[i].first);

    ans = tmax;
    for(i=K+1; i<=N; ++i)
        ans = min(ans, A[i].first - A[i-K].first);

    return ans;
}

int main()
{
    freopen("cursuri.in", "r", stdin);
    freopen("cursuri.out", "w", stdout);
    scanf("%d\n%d %d\n", &T, &N, &K);
    for(int i=1; i<=N; i++)
        scanf("%d %d\n", &A[i].first, &A[i].second);
    if (T==1)
        printf("%d\n", solve_1(A));
    else
        printf("%d\n", solve_2(A));
    return 0;
}
