#include <bits/stdc++.h>
#define nmax 155
using namespace std;

ifstream fin("joc.in");
ofstream fout("joc.out");

struct scor
{
    int A, B;
};

int n, N; /// N = n * n
scor a[nmax * nmax];
scor L[nmax], C[nmax], DP[3], DS[3];
/**
  a[i] =(x,y) : coordonatele din matrice corespunzatoare
                valorii i, unde i=1..n*n
  L[i]=(x, y) : pe linia i sunt puse x X-uri si y zeroruri
  D[i]=(x, y) : pe coloana i sunt puse x X-uri si y zeroruri
  DP[i]=(x,y) : pe diagonalele paralele cu diagonala principala
                sunt puse x X-uri si y zeroruri
  DS[i]=(x,y) : pe diagonalele paralele cu diagonala secundara
                sunt puse x X-uri si y zeroruri
*/

void Matrice()
{
    int i, j, p;
    p = 0;
    for (i = 1; i <= n; i++)
        for (j = 1; j <= n; j++)
        {
            p++;
            a[p].A = i;
            a[p].B = j;
        }
}

void Runda(int r, int &whoWins, int &nrMoves)
{
    int i, laMutare, x, lin, col;
    for (i = 1; i <= n; i++)
        L[i].A = L[i].B = C[i].A = C[i].B = 0;
    for (i = 0; i <= 2; i++)
        DP[i].A = DP[i].B = DS[i].A = DS[i].B = 0;
    whoWins = -1;
    nrMoves = 0;
    laMutare = 1 - r % 2;
    for (i = 1; i <= N; i++)
    {
        fin >> x;
        if (whoWins >= 0) continue;
        nrMoves++;
        lin = a[x].A;
        col = a[x].B;
        /// actualizare scor pe linia lin
        if (laMutare == 0) L[lin].A++;
        else L[lin].B++;
        if (L[lin].A == n) {whoWins = 0; continue;}
        else if (L[lin].B == n) {whoWins = 1; continue;}
        /// actualizare scor pe coloana col
        if (laMutare == 0) C[col].A++;
        else C[col].B++;
        if (C[col].A == n) {whoWins = 0; continue;}
        else if (C[col].B == n) {whoWins = 1; continue;}
        /// actualizare scor pe diag. principala
        if (lin == col)
        {
            if (laMutare == 0) DP[1].A++;
            else DP[1].B++;
            if (DP[1].A == n) {whoWins = 0; continue;}
            else if (DP[1].B == n) {whoWins = 1; continue;}
        }
        /// actualizare scor sub diag. principala; (i+1,i)
        if (lin == col + 1)
        {
            if (laMutare == 0) DP[0].A++;
            else DP[0].B++;
            if (DP[0].A == n - 1) {whoWins = 0; continue;}
            else if (DP[0].B == n - 1) {whoWins = 1; continue;}
        }
        /// actualizare scor deasupra diag. principala; (i-1,i)
        if (lin == col - 1)
        {
            if (laMutare == 0) DP[2].A++;
            else DP[2].B++;
            if (DP[2].A == n - 1) {whoWins = 0; continue;}
            else if (DP[2].B == n - 1) {whoWins = 1; continue;}
        }

        /// actualizare scor pe diag. secundara
        if (lin + col == n + 1)
        {
            if (laMutare == 0) DS[1].A++;
            else DS[1].B++;
            if (DS[1].A == n) {whoWins = 0; continue;}
            else if (DS[1].B == n) {whoWins = 1; continue;}
        }
        /// actualizare scor sub diag. secundara; (lin+col=n+2)
        if (lin + col == n + 2)
        {
            if (laMutare == 0) DS[0].A++;
            else DS[0].B++;
            if (DS[0].A == n - 1) {whoWins = 0; continue;}
            else if (DS[0].B == n - 1) {whoWins = 1; continue;}
        }
        /// actualizare scor deasupra diag. secundara; (lin+col=n)
        if (lin + col == n)
        {
            if (laMutare == 0) DS[2].A++;
            else DS[2].B++;
            if (DS[2].A == n - 1) {whoWins = 0; continue;}
            else if (DS[2].B == n - 1) {whoWins = 1; continue;}
        }
        laMutare = 1 - laMutare;
    }
}

int main()
{
    int nrMoves, whoWins, r, op, K;
    int scorA, scorB, maxMoves;
    fin >> op;
    fin >> n >> K;
    N = n * n;
    Matrice();
    scorA = scorB = maxMoves = 0;
    for (r = 1; r <= K; r++)
    {
        Runda(r, whoWins, nrMoves);
        if (whoWins == 0) scorA++;
        else if (whoWins == 1) scorB++;
        if (whoWins != -1) maxMoves = max(maxMoves, nrMoves);
    }
    if (op == 1) fout << scorA << " " << scorB << "\n";
    else fout << maxMoves << "\n";
    fout.close();
    return 0;
}
