#include <fstream>
#include <cmath>

#define Nmax 100000         //numarul maxim de puncte
#define Cmax 1001           //coordonata maxima
#define IN "triunghiuri.in"
#define OU "triunghiuri.out"

using namespace std;
short x[Nmax], y[Nmax];     //coordonatele punctelor
long N;                     //numarul punctelor
long NrTr;                  //numarul triunghiurilor gasite
short nx[Cmax];

double dist(long i, long j)
{
    return sqrt(pow(x[i] - x[j], 2) + pow(y[i] - y[j], 2));
}

int e_triunghi(long i, long j, long k)
{
    if(dist(i,j) + dist(j,k) > dist(i, k) && dist(i,k) + dist(j,k) > dist(i, j) && dist(i,k) + dist(i,j) > dist(j, k))
    {
        if(y[i] == y[j] && x[k] != x[i] && x[k] != x[j] ) return 1;
        if(y[i] == y[k] && x[j] != x[i] && x[j] != x[k] ) return 1;
        if(y[k] == y[j] && x[i] != x[k] && x[i] != x[j] ) return 1;
    }
    return 0;
}


int main()
{
    long int i, j, k, V, Max;
    //citire date
    ifstream Fin(IN);
    Fin >> V >> N;
    for(i = 1; i <= N; ++i)
    {
        Fin >> x[i] >> y[i];
        nx[ x[i] ]++;
    }
    Fin.close();

    if( V == 1)
    {
        Max = 0;
        for(i = 0; i <= 999; ++i)
            if(nx[i] > Max)
                Max = nx[i];
        ofstream Fou(OU);
        Fou << Max << '\n';
        Fou.close();
    }
    else
    {
        NrTr = 0;
        for(i = 1; i <= N-2; ++i)
            for(j = i+1; j <= N-1; ++j)
                for(k = j+1; k <= N; ++k)
                    if( e_triunghi(i, j, k)) {  NrTr++; NrTr %= 1000003; }

        ofstream Fou(OU);
        Fou << NrTr << '\n';
        Fou.close();
    }
    return 0;
}
