// prof. Mircea Lupse-Turpan - Liceul Teoretic Grigore Moisil Timisoara
#include <fstream>
using namespace std;

ifstream fin("caps.in");
ofstream fout("caps.out");

const int KMax = 100005;
char X[KMax],Y[KMax];
int Frecv1[60][KMax],Frecv2[60][KMax];
int K,Q;
long long N,Nr1,Nr2,Sol;

void Read()
{
    fin >> K >> Q;

    for(int i = 1; i <= K ;++i)
        fin >> X[i];

    for(int i = 1; i <= K; ++i)
        if(X[i] >= 'a' && X[i] <= 'z')
            Y[i] = X[i] - 32;
        else
            Y[i] = X[i] + 32;

    for(int i = 1; i <= K; ++i)
    {
        for(int j = 0; j < 60; ++j)
        {
            Frecv1[j][i] = Frecv1[j][i-1];
            Frecv2[j][i] = Frecv2[j][i-1];
        }
        Frecv1[X[i] - 'A'][i]++;
        Frecv2[Y[i] - 'A'][i]++;
    }

}

char DEI(long long N, long long Nr,int Switch)
{
    if(N <= K)
        {
            if(Switch == 1)
                {
                    Sol += Frecv1[X[N] - 'A'][N];
                    return X[N];
                }

            else
                {
                    Sol += Frecv2[Y[N] - 'A'][N];
                    return Y[N];
                }
        }
    if(N <= 2 * K)
    {
        if(Switch == 1)
            Nr1++;
        else
            Nr2++;
        return DEI(N - K,Nr/4,1-Switch);
    }
    if(N <= 3 * K)
    {
        Nr1++; Nr2++;
        return DEI(N - 2*K,Nr/4,1-Switch);
    }
    if(N <= 4 * K)
    {
        if(Switch == 1)
        {
            Nr1++; Nr2+=2;
        }
        else
        {
            Nr2++; Nr1+=2;
        }
        return DEI(N - 3*K,Nr/4,Switch);
    }
    if(N > Nr * 3/4)
        {
            Nr1 += (Nr * 3/8) / K;
            Nr2 += (Nr * 3/8) / K;
            return DEI(N - Nr * 3/4,Nr/4,Switch);
        }
    if(N > Nr * 2/4)
        {
            Nr1 += (Nr * 2/8) / K;
            Nr2 += (Nr * 2/8) / K;
            return DEI(N - Nr * 2/4,Nr/4,1 - Switch);
        }
    if(N > Nr * 1/4)
        {
            Nr1 += (Nr * 1/8) / K;
            Nr2 += (Nr * 1/8) / K;
            return DEI(N - Nr * 1/4,Nr/4,1 - Switch);
        }
    return DEI(N,Nr/4,Switch);
}

void SolveandPrint()
{
    while(Q--)
    {
        fin >> N;
        long long Nr = K;
        while(Nr < N)
            Nr *=4;
        Sol = 0; Nr1 = Nr2 = 0;
        char Letter = DEI(N,Nr,1);
        Sol += Nr1 * Frecv1[Letter - 'A'][K];
        Sol += Nr2 * Frecv2[Letter - 'A'][K];
        fout << Letter << " " << Sol << "\n";
    }
}

int main()
{
    Read();
    SolveandPrint();
    return 0;
}
