///Kruskal cu pad. disj.
#include <bits/stdc++.h>
using namespace std;

#define NM 31210
ifstream f("ninjago.in");
ofstream g("ninjago.out");

struct edge
{
   int x, y, c;
   char e;
   friend bool operator <(edge a, edge b) {
        return a.c < b.c;
   }
};

vector <int> G1[NM];
vector <edge> G, sol;

int n, m, n1, ctotal;
bool viz[NM];
int t[NM];

void DFS(int nod){
    n1++;
    for(int i=0; i < (int)G1[nod].size(); ++i)
    if (! viz[G1[nod][i]]) {
        viz[G1[nod][i]] = 1;
        DFS(G1[nod][i]);
    }
}

int Radacina(int i)
{
    int k = i;
    while (t[k] > 0)
        k = t[k];
    while (t[i] > 0) {
        t[i] = k;
        i = t[i];
    }
    return i;
}

void Unifica(int i, int j)
{
    t[i] += t[j];
    t[j] = i;
}

void APM()
{
    edge w;

    sort(G.begin(), G.end(), less <edge>());

    for (int i=1; i<=n; ++i)
        t[i] = -1;
    for (int k = 0; k < (int)G.size(); ++k) {
        w = G[k];
        int rx = Radacina(w.x);
        int ry = Radacina(w.y);
        if (rx != ry) {
            ctotal += (w.c) % 625;
            sol.push_back(w);
            Unifica(rx, ry);
        }
    }
}

int main()
{
    int i, j, v;
    edge w;
    string s;

    f >> v >> n >> m;
    for(i=1; i<=m; ++i){
        f >> w.x >> w.y >> s;
        int ct = 0, p = 1, e = 0, ok = 1;
        for(j=0; j<4; ++j, p *= 5){
            if (s[j] == 'E') {
                ok = 0; e++;
                ct += 625;
            }
            else ct += p * (s[j] - 'A' + 1);
        }
        w.e = e; w.c = ct;
        G.push_back(w);

        if (ok) {
            G1[w.x].push_back(w.y);
            G1[w.y].push_back(w.x);
        }
    }

    if (v == 1) {
        DFS(1);
        if (n1 > 1) --n1;
        g << n1 << '\n';
        return 0;
    }

    APM();

    if (v == 2){
        int obs = 0, nre = 0;
        for(i=0; i<(int) sol.size(); ++i){
            if (sol[i].c >= 625) {
                obs++;
                nre += sol[i].e;
            }
        }
        g << obs << '\n' << nre << '\n';
        return 0;
    }
    if (v == 3) {
        g << ctotal << '\n';
        return 0;
    }
    return 0;
}
