#include <cstdio>
#include <algorithm>

using namespace std;

#define maxn 1010
#define inf 2000000000

int n, m;
int d[maxn][maxn];
int sol[2*maxn];

int main()
{
    freopen("permutare.in", "r", stdin);
    freopen("permutare.out", "w", stdout);

    d[0][0]=1;

    for(int i=1; i<=1000; ++i)
    {
        d[i][0]=1;
        for(int j=1; j<=i; ++j)
            d[i][j]=min(1LL*d[i][j-1]+d[i-1][j], 1LL*inf);
    }

    int tip, poz;

    while(scanf("%d%d", &tip, &n) == 2)
    {
        int p1=1, p2=n+1;
        int inc=n, des=n;
        if(tip==1)
        {
            scanf("%d", &poz);
            for(int i=1; i<=2*n; ++i)
            {
                if(des==0)
                {
                    sol[p2++]=i;
                    --inc;
                }
                else
                if(d[inc][des-1]>=poz)
                {
                    sol[p1++]=i;
                    --des;
                }
                else
                {
                    sol[p2++]=i;
                    poz-=d[inc][des-1];
                    --inc;
                }
            }
            for(int i=1; i<=2*n; ++i)
                printf("%d ", sol[i]);
            printf("\n");
        }
        else
        {
            poz=1;
            for(int i=1; i<=2*n; ++i)
                scanf("%d", &sol[i]);
            for(int i=1; i<=2*n; ++i)
            {
                if(sol[p1]==i)
                {
                    --des;
                    ++p1;
                }
                else
                {
                    poz+=d[inc][des-1];
                    --inc;
                    ++p2;
                }
            }
            printf("%d\n", poz);
        }
    }

    return 0;
}
