//Dana Lica
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#define inf 100001
#define Nmax 1010


struct curs {int first; int second;}A[Nmax];

int N, K, T, Max, Lg, i;

int max(int a, int b){ return (a > b ? a : b);}
int min(int a, int b){ return (a < b ? a : b);}

void sortN2_second(struct curs A[Nmax]){
   struct curs aux;
   int i, j;

    for(i=1; i<N; i++)
        for(j=i+1; j<=N; j++)
           if(A[i].second>A[j].second || A[i].second== A[j].second && A[i].first>A[j].first)
                aux=A[i], A[i]=A[j], A[j]=aux;
}
void sortN2_first(struct curs A[Nmax]){
    struct curs aux;
    int i, j;
    for(i=1; i<N; i++)
        for( j=i+1; j<=N; j++)
           if(A[i].first>A[j].first)
                aux=A[i], A[i]=A[j], A[j]=aux;
}

int solve_1(struct curs A[Nmax]){
    int nr = 1, Sala[Nmax], Min, poz, i, j;
    memset(Sala,0,sizeof(Sala));

    sortN2_second(A);
    Sala[1]=A[1].second;
    for(i=2; i<=N; i++){
        Min = inf;
        for(j=1; j<=K; j++)
        if (A[i].first>=Sala[j] && Min> A[i].first - Sala[j]){
            Min = A[i].first - Sala[j];
            poz = j;
        }
        if(Min!= inf){ nr++; Sala[poz]=A[i].second;}
    }
    return nr;
}

int solve_2(struct curs A[Nmax])
{
    int i, tmax=0, ans;

    sortN2_first(A);

    for(i=1; i<=N; ++i)
        tmax = max(tmax, A[i].second - A[i].first);

    ans = tmax;
    for(i=K+1; i<=N; ++i)
        ans = min(ans, A[i].first - A[i-K].first);

    return ans;
}

int main()
{
    freopen("cursuri.in", "r", stdin);
    freopen("cursuri.out", "w", stdout);
    scanf("%d\n%d %d\n", &T, &N, &K);
    assert(T==1 || T==2);
    assert(N>=1 && N<=1000);
    assert(K>=1 && K<=1000);
    for(i=1; i<=N; i++){
        scanf("%d %d\n", &A[i].first, &A[i].second);
        assert(A[i].first>=1 && A[i].first<=100000);
        assert(A[i].second>=1 && A[i].second<=100000);
    }
    if (T==1)
        printf("%d\n", solve_1(A));
    else
        printf("%d\n", solve_2(A));
    return 0;
}
