//Dana Lica
#include <cstdio>
#include <algorithm>
#include <cstring>
#define Nmax 155

using namespace std;


int diag1T[5], diag1S[5], diag2T[5], diag2S[5], LT[Nmax], LS[Nmax], CT[Nmax], CS[Nmax];
int N, K, test, T, winS, winT, i, x, moves;
bool win;

bool addT(int x)
{
    if(win) return false;
    int linie, coloana, dif;
    if(x%N==0) linie = x/N, coloana = N;
    else linie = x/N+1, coloana = x%N;

    ++LT[linie];
    if(LT[linie]==N) return true;

    ++CT[coloana];
    if(CT[coloana]==N) return true;

    dif = linie-coloana+2;
    if(dif>=1 && dif<=3)
    {
        ++diag1T[dif];
        if((dif==2 && diag1T[dif]==N) || (dif!=2 && diag1T[dif]==N-1)) return true;
    }

    dif = linie+coloana-(N-1);
    if(dif>=1 && dif<=3)
    {
        ++diag2T[dif];
        if((dif==2 && diag2T[dif]==N) || (dif!=2 && diag2T[dif]==N-1)) return true;
    }

    return false;
}

bool addS(int x)
{
    if(win) return false;
    int linie, coloana, dif;
    if(x%N==0) linie = x/N, coloana = N;
    else linie = x/N+1, coloana = x%N;

    ++LS[linie];
    if(LS[linie]==N) return true;

    ++CS[coloana];
    if(CS[coloana]==N) return true;

    dif = linie-coloana+2;
    if(dif>=1 && dif<=3)
    {
        ++diag1S[dif];
        if((dif==2 && diag1S[dif]==N) || (dif!=2 && diag1S[dif]==N-1)) return true;
    }

    dif = linie+coloana-(N-1);
    if(dif>=1 && dif<=3)
    {
        ++diag2S[dif];
        if((dif==2 && diag2S[dif]==N) || (dif!=2 && diag2S[dif]==N-1)) return true;
    }

    return false;
}

void initialize()
{
    memset(LT, 0, sizeof(LT));
    memset(LS, 0, sizeof(LS));
    memset(CT, 0, sizeof(CT));
    memset(CS, 0, sizeof(CS));
    memset(diag1T, 0, sizeof(diag1T));
    memset(diag1S, 0, sizeof(diag1S));
    memset(diag2T, 0, sizeof(diag2T));
    memset(diag2S, 0, sizeof(diag2S));
}

int main()
{
    freopen("joc.in", "r", stdin);
    freopen("joc.out", "w", stdout);

    scanf("%d\n", &T);
    scanf("%d %d\n", &N, &K);

    for(test=1; test<=K; ++test)
    {
        initialize();
        win = 0;
        for(i=1; i<=N*N; ++i)
        {
            scanf("%d", &x);

            if((test%2==1 && i%2==1) || (test%2==0 && i%2==0))
            {
                if(addT(x))
                {
                        ++winT;
                        win = 1;
                        moves = max(moves, i);
                }
            }
            else if(addS(x))
                {
                    ++winS;
                    win = 1;
                    moves = max(moves, i);
                }
        }
    }

    if(T==1) printf("%d %d\n", winT, winS);
    else printf("%d\n", moves);

    return 0;
}
